<h2>Welcome to VEROS.</h2>

This package should be used by any party that wants to integrate the VEROS cryptocurrency in their services.

<h3>Getting started</h3>

Start by installing the module using:

`npm install veros --save`

Then import the library into your project by adding the following line:

`var veros = require('veros');`


In order to start using VEROS you need to connect to your local Ethereum node. 
Please make sure the node is up and running with the RPC API available and open.

In order to connect to the node run the following code:

`
veros.connectToEthereumNode(address,
coinbaseAddress,
coinbasePassword,
sandbox,
completion);
`

The parameters are:

- address = The HTTP address of the Ethereum node `http://127.0.0.1:8545`
- coinbaseAddress = The Ethereum address of your coinbase account. This is used to pay ETH transaction fees
- coinbasePassword = The password to your coinbase account
- sandbox = a boolean that indicates if the ethereum is running on `testnet` or `production`
- completion(err,blockNumber) = The complication block that is called after the connection is based. It will return an error or the current `blockNumber` or your ethereum node.


<h3>Available methods</h3>

- getBlockNumber = Returns the current block nunmber
- createAccount(password) = Creates a new account with the specified password
- checkAccount(address,password) = Returns true if the credentials are correct.
- listAccounts = Returns a list of all accounts on the current Ethereum node.
- getVerosBalance(address) = Returns the VEROS balance of the selected address
- sendVeros(fromAddress, fromPassword, recipinetAddress,amount) = Sends VEROS from one account to another. You need to specify the credentials of the sender account.

