var Web3 = require('web3');
var web3 = new Web3();

var verosContract;
var verosInstance;

var coinbaseAddress;
var coinbasePassword;

var _sandbox;

/*
 * Connect to local Ethereum Node
 */
function connectToEthereumNode(ip,address,password,sandbox,completion) {
    web3.setProvider(new web3.providers.HttpProvider(ip));

    if (!sandbox) {
        sandbox = false;
    }
    _sandbox = sandbox;
    if (sandbox) {
        verosContract = web3.eth.contract([{"constant":false,"inputs":[{"name":"_spender","type":"address"},{"name":"_value","type":"uint256"}],"name":"approve","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[],"name":"totalSupply","outputs":[{"name":"totalSupply","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_from","type":"address"},{"name":"_to","type":"address"},{"name":"_value","type":"uint256"}],"name":"transferFrom","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"receivingAddress","type":"address"},{"name":"ownerAddress","type":"address"}],"name":"addReceivingAddress","outputs":[],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"receivingAddress","type":"address"}],"name":"getReceivingAddressOwner","outputs":[{"name":"ownerAddress","type":"address"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"}],"name":"balanceOf","outputs":[{"name":"balance","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"senderAddress","type":"address"},{"name":"recipientAddress","type":"address"},{"name":"amount","type":"uint256"}],"name":"registerInternalTransaction","outputs":[],"payable":false,"type":"function"},{"constant":true,"inputs":[],"name":"availableSupply","outputs":[{"name":"availableSupply","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_to","type":"address"},{"name":"_senderIdentifier","type":"address"},{"name":"_value","type":"uint256"}],"name":"transfer","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"},{"name":"_spender","type":"address"}],"name":"allowance","outputs":[{"name":"remaining","type":"uint256"}],"payable":false,"type":"function"},{"inputs":[{"name":"genesisWalletAddress","type":"address"},{"name":"mainWalletAddress","type":"address"},{"name":"stakingWalletAddress","type":"address"},{"name":"stakeholderWalletAddress","type":"address"},{"name":"investorWalletAddress","type":"address"},{"name":"feesWalletAddress","type":"address"}],"type":"constructor"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_from","type":"address"},{"indexed":true,"name":"_to","type":"address"},{"indexed":true,"name":"_receivingAddress","type":"address"},{"indexed":false,"name":"_senderIdentifier","type":"address"},{"indexed":false,"name":"_value","type":"uint256"},{"indexed":false,"name":"_internalTransaction","type":"bool"}],"name":"Transfer","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_owner","type":"address"},{"indexed":true,"name":"_spender","type":"address"},{"indexed":false,"name":"_value","type":"uint256"}],"name":"Approval","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"recipientAddress","type":"address"},{"indexed":true,"name":"ownerAddress","type":"address"}],"name":"RegisterReceivingAddress","type":"event"}]);
        verosInstance = verosContract.at("0x076A5BD36bF6b8C3f174c0519be28b25f30108Ff");
    } else {
        verosContract = web3.eth.contract([{"constant":false,"inputs":[{"name":"_spender","type":"address"},{"name":"_value","type":"uint256"}],"name":"approve","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[],"name":"totalSupply","outputs":[{"name":"totalSupply","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_from","type":"address"},{"name":"_to","type":"address"},{"name":"_value","type":"uint256"}],"name":"transferFrom","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"receivingAddress","type":"address"},{"name":"ownerAddress","type":"address"}],"name":"addReceivingAddress","outputs":[],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"receivingAddress","type":"address"}],"name":"getReceivingAddressOwner","outputs":[{"name":"ownerAddress","type":"address"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"}],"name":"balanceOf","outputs":[{"name":"balance","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"senderAddress","type":"address"},{"name":"recipientAddress","type":"address"},{"name":"amount","type":"uint256"}],"name":"registerInternalTransaction","outputs":[],"payable":false,"type":"function"},{"constant":true,"inputs":[],"name":"availableSupply","outputs":[{"name":"availableSupply","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_to","type":"address"},{"name":"_senderIdentifier","type":"address"},{"name":"_value","type":"uint256"}],"name":"transfer","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"},{"name":"_spender","type":"address"}],"name":"allowance","outputs":[{"name":"remaining","type":"uint256"}],"payable":false,"type":"function"},{"inputs":[{"name":"genesisWalletAddress","type":"address"},{"name":"mainWalletAddress","type":"address"},{"name":"stakingWalletAddress","type":"address"},{"name":"stakeholderWalletAddress","type":"address"},{"name":"investorWalletAddress","type":"address"},{"name":"feesWalletAddress","type":"address"}],"type":"constructor"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_from","type":"address"},{"indexed":true,"name":"_to","type":"address"},{"indexed":true,"name":"_receivingAddress","type":"address"},{"indexed":false,"name":"_senderIdentifier","type":"address"},{"indexed":false,"name":"_value","type":"uint256"},{"indexed":false,"name":"_internalTransaction","type":"bool"}],"name":"Transfer","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_owner","type":"address"},{"indexed":true,"name":"_spender","type":"address"},{"indexed":false,"name":"_value","type":"uint256"}],"name":"Approval","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"recipientAddress","type":"address"},{"indexed":true,"name":"ownerAddress","type":"address"}],"name":"RegisterReceivingAddress","type":"event"}]);
        verosInstance = verosContract.at("0x076A5BD36bF6b8C3f174c0519be28b25f30108Ff");
    }

    coinbaseAddress = address;
    coinbasePassword = password;
    try {
        var blockNumber = getBlockNumber();
        completion(null,blockNumber);
    } catch(err) {
        completion(err,null);
    }
}

function getBlockNumber() {
    return web3.eth.blockNumber;
}

function createAccount(password) {
    return web3.personal.newAccount(password);
}

/*
 * Check the credentials for the selected account
 */
function checkAccount(address,password) {
    if (address.length != 42) {
        console.log("Err: Invalid address length (" + address + ")");
        return false;
    }
    try {
        return web3.personal.unlockAccount(address.slice(2), password);
    } catch (err) {
        return false;
    }
}
/*
 * Return VEROS balance
 */
function getVerosBalance(address) {
    return balance = verosInstance.balanceOf.call(address);
}

/*
 * List all accounts
 */
function listAccounts() {
    return web3.eth.accounts;
}

/*
 * Send VEROS
 */
function sendVeros(fromAddress, fromPassword, recipientAddress,senderIdentifier,amount,completion) {
    if (!checkAccount(fromAddress,fromPassword)) {
        return completion("Cannot unlock sender account",null);
    }
    if (getVerosBalance(fromAddress) < (amount + 3000)) {
        return completion("Insufficient amount",null);
    }
    try {
        if (!senderIdentifier) {
            senderIdentifier = 0x0;
        }
        verosInstance.transfer(
            recipientAddress,
            senderIdentifier,
            amount, {
            from: fromAddress
        }, function (err, tx) {
            completion(err, tx);
        });
    } catch (err) {
        completion(err,null);
    }
}

function addReceivingAddress(registerAccount,registerAccountPassword,ownerAddress,completion) {
    if (!checkAccount(registerAccount,registerAccountPassword)) {
        return completion("Cannot unlock sender account",null,null);
    }
    var receivingAddress = "0x" + randomAddress(40);
    verosInstance.addReceivingAddress(receivingAddress,ownerAddress,{
        from: registerAccount
    },function(err,tx) {
        if (err) {
            completion(err,null,null)
        } else {
            completion(null,tx,receivingAddress);
        }
    });
}

function getReceivingAddress(ownerAddress,completion) {
    var startBlock;
    if (_sandbox) {
        startBlock = 1870609;
    } else {
        startBlock = 1870609;
    }

    var registerAddressEvent = verosInstance.RegisterReceivingAddress({ownerAddress:ownerAddress}, {fromBlock:startBlock, toBlock: 'latest'});
    registerAddressEvent.get(function(error, events) {
        var receivingAddresses = [];
        events.forEach(function(event,index) {
           var ownerAddress = event.args['ownerAddress'];
           var receivingAddress = event.args['ownerAddress'];
           var transactionHash = event.transactionHash;
           var transactionTimestamp = web3.eth.getBlock(event.blockNumber).timestamp;

            receivingAddresses.push({
               ownerAddress:ownerAddress,
                receivingAddress:receivingAddress,
                transactionHash:transactionHash,
                transactionTimestamp:transactionTimestamp
            });
        });
        completion(error,receivingAddresses);
    });
}

function getTransfers(userAddress,completion) {
    var startBlock;
    if (_sandbox) {
        startBlock = 1870609;
    } else {
        startBlock = 1870609;
    }
    if (userAddress) {
        var transferEvent = verosInstance.Transfer({_from:userAddress}, {fromBlock: startBlock, toBlock: 'latest'});
        var outgoingTransfers = [];
        var incomingTransfers = [];
        transferEvent.get(function (error, events) {
            events.forEach(function(event,index) {
                outgoingTransfers.push(transferEventToObject(event));
            });

            var transferEvent = verosInstance.Transfer({_to:userAddress}, {fromBlock: startBlock, toBlock: 'latest'});
            transferEvent.get(function (error, events) {
                events.forEach(function (event, index) {
                    incomingTransfers.push(transferEventToObject(event));
                });

                completion(error,  {
                    incoming:incomingTransfers,
                    outgoing:outgoingTransfers
                });
            });
        });
    } else {
        var transferEvent = verosInstance.Transfer(null, {fromBlock: startBlock, toBlock: 'latest'});
        transferEvent.get(function (error, events) {
            var transfers = [];
            events.forEach(function(event,index) {
                transfers.push(transferEventToObject(event));
            });
            completion(error, transfers);
        });
    }
}

function transferEventToObject(transferEvent) {
    return {
        senderAddress:transferEvent.args["_from"],
        receiverAddress:transferEvent.args["_to"],
        receivingAddress:transferEvent.args["_receivingAddress"],
        senderIdentifier:transferEvent.args["_senderIdentifier"],
        amount:transferEvent.args["value"],
        internal:transferEvent.args["_internalTransaction"],
        transactionHash:transferEvent.transactionHash,
        transactionTimestamp: web3.eth.getBlock(transferEvent.blockNumber).timestamp
    }
}

module.exports = {
    // Init
    connectToEthereumNode:connectToEthereumNode,
    getBlockNumber:getBlockNumber,
    web3:web3,
    verosInstance:verosInstance,

    // Accounts
    createAccount:createAccount,
    checkAccount:checkAccount,
    listAccounts:listAccounts,

    // Veros
    getVerosBalance:getVerosBalance,
    sendVeros:sendVeros,
    addReceivingAddress:addReceivingAddress,
    getReceivingAddress:getReceivingAddress,

    // Events
    getTransfers:getTransfers
};

function randomAddress(length)
{
    var text = "";
    var possible = "0123456789abcdef";

    for( var i=0; i < length; i++ )
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
}
